//importe les librairies
import processing.serial.*; 
import cc.arduino.*; 

//Déclare les variables
//déplacement
float deplacementY;
float deplacementX;  
//déplacement précédent
float previousDeplacementX;
float previousDeplacementY;
//sauver l'image
int rec;
//effacer
int erase;
//pour differencier les noms des images qu'on enregistre 
int i = 1;
//valeurs des différents capteurs
int a;
int b;
int c;
int d;
//déclare valeur arduino
Arduino arduino;

void setup() {
  //taille du sketch
  size(800, 600);
  //smooth le dessin
  smooth(); 
  //imprime la liste des serials pour repérer celui que l'on va utiliser
  println(Serial.list()); 
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  //déclare comme pour arduino l'état des pins
  arduino.pinMode(3, Arduino.INPUT);
  arduino.pinMode(7, Arduino.INPUT);
  //couleur de fond du sketch
  background(0);
  //définit la rapidité d'exécution du sketch
  frameRate(30);
}

void draw() {
//lit les valeurs des différents capteurs  
a = (arduino.analogRead(0));
b = (arduino.analogRead(1));
c = (arduino.digitalRead(3));
d = (arduino.digitalRead(7));
//associe les valeurs des potentiomètres aux variables de déplacement X et Y    
deplacementX=a;
deplacementY=b;
//map les valeurs par rapport à la taille du sketch  
deplacementX=map(deplacementX, 0, 1023, 100, 700);
deplacementY=map(deplacementY, 0, 1023, 100, 500);
//associe les valeurs des capteurs pour commander l'effacement et l'enregistrement
rec=c;
erase=d;

//Dessine le pinceau
//couleur RGB aléatoire
stroke(random(0, 255), random(0, 255),random(0, 255));
//taille du trait
strokeWeight(4);
//dessine la ligne avec les valeurs actuelles du potar et les dernières enregistrés
line(previousDeplacementX, previousDeplacementY, deplacementX,deplacementY);
//Si on appuie sur le bouton l'image du fond est enregistré dans le même dossier que le code 
  if (rec == Arduino.HIGH) {
    save(i+"ardoiseMagique.jpg");
    i++;
    println("SAVE");
    delay(100);
  }
//Si le tilt est activé l'image est effacée
  if (erase == Arduino.LOW) {
    background(0);
    println("ERASE");
  }        
  
  previousDeplacementX=deplacementX;
  previousDeplacementY=deplacementY;
//imprime les valeurs de déplacement
  print("deplacementX = ");
  print(deplacementX);
  print("\t");
  print("deplacementY = ");
  println(deplacementY);
}

